using UnityEngine;
using System.Collections;

public class UFOScript : MonoBehaviour 
{
	public float speed = 1.0f;
	public float timer = 0.0f;
	public float fireRate = 1.0f;
	public GameObject projectile = null;
	public GameObject[] gunPlacements = new GameObject[3];
	public float deathTimer = 0.0f;
	public float dieAfter = 10.0f;
	public AudioClip ufoHit = null;
	public GameObject brokenUFO = null;
	// Use this for initialization
	void Start () 
	{
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		transform.Translate(Vector3.down * Time.deltaTime * speed);
		timer += Time.deltaTime;
		if(timer >= fireRate)
		{
			timer = 0.0f;
			Fire();
		}
		deathTimer += Time.deltaTime;
		if(deathTimer >= dieAfter)
		{
			Destroy(gameObject);
		}
	}
	void Fire()
	{
		foreach (GameObject gunPlacement in gunPlacements)
		{
			Instantiate(projectile, gunPlacement.transform.position, Quaternion.Euler(180,0,0));
		}
	}
		
	void OnTriggerEnter(Collider other)
	{
		if(other.gameObject.tag == "projectile")
		{
			AudioSource.PlayClipAtPoint(ufoHit, transform.position);
			Instantiate(brokenUFO, gameObject.transform.position, Quaternion.Euler(0,0,180));
			Destroy(gameObject);
			gameManager.score += 250;
		}
		if(other.gameObject.tag == "Player")
		{
			AudioSource.PlayClipAtPoint(ufoHit, transform.position);
			Instantiate(brokenUFO, gameObject.transform.position, Quaternion.Euler(0,0,180));
			Destroy(gameObject);
			if(gameManager.shield > 0)
				gameManager.shield -= 10;
			else if(gameManager.shield <= 0)
				gameManager.health -= 10;
		}
	}
	
}
