using UnityEngine;
using System.Collections;

public class gameManager : MonoBehaviour 
{
	public GUIStyle HUDStyle;
	public GUIStyle HUDStyleScore;
	public static int score = 0;
	public static int lives = 3;
	public GameObject healthBar = null;
	public GameObject shieldBar = null;
	public Vector3 shieldVec = new Vector3(1,1,1);
	public Vector3 healthVec = new Vector3(1,1,1);
	public GameObject playerShip = null;
	public static int health = 100;
	public static int shield = 100;
	GameObject[] findPlayer = new GameObject[1];
	public static bool gameOver = false;
	public AudioClip deathSound = null;
	public static float difficulty = 0.1f;
	public GameObject brokenPlayer = null;
	// Use this for initialization
	void Start () 
	{
		Instantiate(playerShip, new Vector3(-0.1282912f,-2.130133f,4.784287f), Quaternion.identity);
	}
	
	// Update is called once per frame
	void Update () 
	{
		healthVec.x = health / 100.0f;
		healthBar.transform.localScale = healthVec;
		
		shieldVec.x = shield / 100.0f;
		shieldBar.transform.localScale = shieldVec;
	
		
		if(gameManager.health <= 0 && !gameOver)
		{
			findPlayer = GameObject.FindGameObjectsWithTag("Player");
			Instantiate(brokenPlayer, findPlayer[0].transform.position, Quaternion.identity); 
			Destroy(findPlayer[0]);
			AudioSource.PlayClipAtPoint(deathSound, transform.position);
			if(lives > 0)
			{
				lives--;
				StartCoroutine(Spawn(2.0f));
			}
			else
			{
				gameOver = true;
			}
		}
	}
	
	void OnGUI()
	{
		//GUI.Label(new Rect(10,40,100,20), "HEALTH: " + health.ToString(), HUDStyle);
		//GUI.Label(new Rect(10,10,100,20), "SHIELD: " + shield.ToString(), HUDStyle);
		GUI.Label(new Rect(10,100,100,20), "SCORE: " + score.ToString(), HUDStyleScore);
		GUI.Label(new Rect(10,130,100,20), "LIVES: " + lives.ToString(), HUDStyleScore);
		if(gameOver)
		{
			GUI.Label(new Rect(Screen.width/2-50,Screen.height/2-50,100,100), "GAME OVER!", HUDStyleScore);
			if(GUI.Button(new Rect(Screen.width/2-75,Screen.height/2,250,100), "Click here to play again!"))
			{
				Application.LoadLevel(1);
				gameOver = false;
				health = 100;
				shield = 100;
				lives = 3;
				score = 0;
			}
		}
	}
	
	IEnumerator Spawn(float delay)
	{
		health = 100;
		shield = 100;
		yield return new WaitForSeconds(delay);
		Instantiate(playerShip, new Vector3(-0.1282912f,-2.130133f,4.784287f), Quaternion.identity);
	}

}


